/*****************************************************************************
 *
 * This program is free software ; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Id$
 *
 ****************************************************************************/

#include <windows.h>

#define GETRAWFRAMEBUFFER   0x00020001

typedef struct RawFrameBufferInfo
{
	WORD wFormat;
	WORD wBPP;
	char *pFramePointer;
	int  cxStride;
	int  cyStride;
	int  cxPixels;
	int  cyPixels;

} RawFrameBufferInfo;

RawFrameBufferInfo Info;

extern void Draw(void* Src,void* Dest,int DestPitch,int Height);
extern BOOL SetKMode(BOOL bFlag);

typedef struct gapi
{
	int Unused;
	void* Address;
	int Pitch;
	int Width;
	int Height;
} gapi;

#define SAFE 32
int Inited;
short Buffer[320+SAFE+SAFE][240];

void _IsDMAReady(gapi** Stack)
{
	if (!Inited)
	{
		int i;

		// now this one is really-really ugly
		// we hack into gx.dll's internal structure to 
		// change the frame buffer address

		for (i=0;i<10;++i)
		{
			gapi* p = Stack[i];
			if (!((int)p & 3) && ((int)p>0) && !IsBadReadPtr(p,sizeof(gapi)) && p->Height==320 && p->Width==240 && p->Pitch==240*2)
			{
				p->Address = &Buffer[SAFE][0];
				break;
			}
		}

		Inited = 1;
	}
}

void DmaVRAMtoDRAM(int a,int b,int c,int d)
{
	//not supported...
}

void DmaDRAMtoVRAM(int ViewLeft,int ViewTop,int ViewWidth,int ViewHeight)
{
	if (ViewTop < 0)
	{
		ViewHeight += ViewTop;
		ViewTop = 0;
	}
	if (ViewTop + ViewHeight > 320)
		ViewHeight = 320 - ViewTop;
	if (ViewHeight > 0)
	{
		BOOL Old = SetKMode(TRUE);
		Draw(Buffer[ViewTop+SAFE],Info.pFramePointer + ViewTop*Info.cyStride*2,Info.cyStride,ViewHeight);
		SetKMode(Old);
	}
}

int DllMain(HANDLE Module,DWORD Reason,LPVOID p)
{
	HDC DC;

	switch (Reason)
	{
	case DLL_PROCESS_ATTACH:

		DC = GetDC(NULL);
		memset(&Info,0,sizeof(Info));
		ExtEscape(DC, GETRAWFRAMEBUFFER, 0, NULL, sizeof(RawFrameBufferInfo), (char*)&Info);
		ReleaseDC(NULL,DC);

		if (!Info.pFramePointer || Info.cxPixels != 480 || Info.cyPixels != 640 || Info.cxStride != 2)
			return FALSE; // use original gx.dll 

		break;

	case DLL_PROCESS_DETACH:
		break;
	}

	return TRUE;
}
